<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>

        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-banner
            class="bg-grey-3 text-grey-8"
          >
            <translate>The harvest and residues data are used to compute the nutrient requirements for the crop.</translate>
          </q-banner>

          <q-card-section>
            <q-input
              v-model.number="storeCropTargetYield"
              filled
              :label="$gettext('Target yield')"
              type="number"
              :placeholder="$gettext('Target yield')"
              :suffix="cropYieldUnitDisplay"
              :rules="[val => val > 0 || $gettext('This field must be positive')]"
              :min="0"
              step="1"
              hide-bottom-space
              class="q-mt-md"
            />
          </q-card-section>

          <q-card-section>
            <div class="text-subtitle2 text-grey-8 q-pb-sm">
              <translate>Harvest nutrient content</translate>
            </div>
            <div class="row q-gutter-md">
              <q-input
                v-model.number="storeHarvestNitrogen"
                filled
                type="number"
                :suffix="$gettext('%')"
                :rules="[val => (val >= 0 && val <= 100) || $gettext('This field value must be between 0 and 100')]"
                :min="0"
                :max="100"
                step="0.01"
                hide-bottom-space
                class="col nutrient-content"
              >
                <template #before>
                  <div class="q-pa-none text-h6 text-n-color">
                    <translate>N</translate>
                  </div>
                </template>
              </q-input>
              <q-input
                v-model.number="storeHarvestPhosphorus"
                filled
                type="number"
                :suffix="$gettext('%')"
                :rules="[val => (val >= 0 && val <= 100) || $gettext('This field value must be between 0 and 100')]"
                :min="0"
                :max="100"
                step="0.01"
                hide-bottom-space
                class="col"
              >
                <template #before>
                  <div class="q-pa-none text-h6 text-p-color">
                    <translate>P</translate>
                  </div>
                </template>
              </q-input>
              <q-input
                v-model.number="storeHarvestPotassium"
                filled
                type="number"
                :suffix="$gettext('%')"
                :rules="[val => (val >= 0 && val <= 100) || $gettext('This field value must be between 0 and 100')]"
                :min="0"
                :max="100"
                step="0.01"
                hide-bottom-space
                class="col"
              >
                <template #before>
                  <div class="q-pa-none text-h6 text-k-color">
                    <translate>K</translate>
                  </div>
                </template>
              </q-input>
            </div>
          </q-card-section>

          <q-card-section class="q-pt-sm">
            <q-expansion-item
              v-model="storeHarvestAndResiduesAdvanced"
              :label="$gettext('Advanced parameters')"
              header-class="text-subtitle2 text-grey-8 q-px-none q-pt-none"
            >
              <q-field
                label-slot
                bottom-slots
                stack-label
                filled
                clearable
              >
                <template #label>
                  <translate>Residues exported at the end of the season</translate>
                </template>
                <template #append>
                  <span
                    class="text-black"
                    style="font-size: 14px"
                  >{{ storeResiduesLeftInField }} %</span>
                </template>
                <template #control>
                  <q-slider
                    v-model="storeResiduesLeftInField"
                    :min="0"
                    :max="100"
                    :step="1"
                  />
                </template>
              </q-field>
              <q-field
                label-slot
                bottom-slots
                stack-label
                filled
                clearable
              >
                <template #label>
                  <translate>Harvest index</translate>
                </template>
                <template #hint>
                  <translate>Ratio of grain to total shoot dry matter</translate>
                </template>
                <template #append>
                  <span
                    class="text-black"
                    style="font-size: 14px"
                  >{{ storeHarvestIndex }} %</span>
                </template>
                <template #control>
                  <q-slider
                    v-model="storeHarvestIndex"
                    :min="0"
                    :max="100"
                    :step="1"
                  />
                </template>
              </q-field>

              <q-field
                label-slot
                bottom-slots
                stack-label
                filled
                clearable
                class="q-mt-md"
              >
                <template #label>
                  <translate>CV</translate>
                </template>
                <template #hint>
                  <translate>Coefficient of variation</translate>
                </template>
                <template #append>
                  <span
                    class="text-black"
                    style="font-size: 14px"
                  >{{ storeHarvestCV }} %</span>
                </template>
                <template #control>
                  <q-slider
                    v-model="storeHarvestCV"
                    :min="0"
                    :max="100"
                    :step="1"
                  />
                </template>
              </q-field>
            </q-expansion-item>
          </q-card-section>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              class="q-pa-none"
              vertical
              align="stretch"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="!canContinue"
                @click="onClickNext"
              >
                <translate>Next</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import { getConversionRatio, getDisplayUnit } from 'src/services/fieldbook/fertilization/fertilizationPlan'

export default {
  name: 'NavigatorF3HarvestAndResiduesPage',
  components: {
    GenericLayout,
    Header,
    Footer
  },
  mixins: [PlatformMixin, AlgorithmsMixins],
  computed: {
    pageTitle () {
      return this.$gettext('Harvest and residues')
    },
    pageSubTitle () {
      return 'Navigator F3'
    },
    canContinue () {
      return this.isParameterSet(this.storeCropTargetYield) &&
        this.isParameterSet(this.storeResiduesLeftInField) &&
        this.isParameterSet(this.storeHarvestIndex) &&
        this.isParameterSet(this.storeHarvestCV) &&
        this.isParameterSet(this.storeHarvestNitrogen) &&
        this.isParameterSet(this.storeHarvestPhosphorus) &&
        this.isParameterSet(this.storeHarvestPotassium)
    },
    cropProfile () {
      return this.$store.state.fertilizationPlan.parameters.cropProfile
    },
    plotCropYield () {
      return this.$store.state.fertilizationPlan.target.plot_plant_variety?.crop_yield
    },
    cropYieldUnitDisplay () {
      return getDisplayUnit(this.displayUnitConfig)
    },
    displayUnitConfig () {
      return {
        surface: this.$store.state.fertilizationPlan.parameters.displaySurfaceUnit
      }
    },
    storeCropTargetYield: {
      get () {
        const cropTargetYield = this.$store.state.fertilizationPlan.parameters.cropTargetYield ?? null
        if (cropTargetYield === null) {
          return null
        } else {
          const conversionRatio = getConversionRatio(this.displayUnitConfig)
          return cropTargetYield * conversionRatio
        }
      },
      set (v) {
        let value = null
        if (v > 0) {
          const conversionRatio = getConversionRatio(this.displayUnitConfig)
          value = v / conversionRatio
        }
        this.updateParameter('cropTargetYield', value)
      }
    },
    storeResiduesLeftInField: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.residuesLeftInField
      },
      set (v) {
        this.updateParameter('residuesLeftInField', v)
      }
    },
    storeHarvestIndex: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.harvestIndex
      },
      set (v) {
        this.updateParameter('harvestIndex', v)
      }
    },
    storeHarvestCV: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.harvestCV
      },
      set (v) {
        this.updateParameter('harvestCV', v)
      }
    },
    storeHarvestNitrogen: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.harvestNitrogen
      },
      set (v) {
        this.updateParameter('harvestNitrogen', v)
      }
    },
    storeHarvestPhosphorus: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.harvestPhosphorus
      },
      set (v) {
        this.updateParameter('harvestPhosphorus', v)
      }
    },
    storeHarvestPotassium: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.harvestPotassium
      },
      set (v) {
        this.updateParameter('harvestPotassium', v)
      }
    },
    storeHarvestAndResiduesAdvanced: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.harvestAndResiduesAdvanced
      },
      set (v) {
        this.updateParameter('harvestAndResiduesAdvanced', v)
      }
    }
  },
  mounted () {
    // Set default values from the selected crop profile
    if (!this.isParameterSet(this.storeCropTargetYield) && this.plotCropYield !== null) {
      // to not convert yield as plot crop yield is already in kg/ha
      this.updateParameter('cropTargetYield', this.plotCropYield)
    }
    if (!this.isParameterSet(this.storeHarvestAndResiduesAdvanced)) {
      this.storeHarvestAndResiduesAdvanced = false
    }
    if (!this.isParameterSet(this.storeResiduesLeftInField)) {
      this.storeResiduesLeftInField = this.cropProfile.residues_left_in_field
    }
    if (!this.isParameterSet(this.storeHarvestIndex)) {
      this.storeHarvestIndex = this.cropProfile.harvest_index
    }
    if (!this.isParameterSet(this.storeHarvestCV)) {
      this.storeHarvestCV = this.cropProfile.cv
    }
    if (!this.isParameterSet(this.storeHarvestNitrogen)) {
      this.storeHarvestNitrogen = this.cropProfile.harvest_nitrogen_content
    }
    if (!this.isParameterSet(this.storeHarvestPhosphorus)) {
      this.storeHarvestPhosphorus = this.cropProfile.harvest_phosphorus_content
    }
    if (!this.isParameterSet(this.storeHarvestPotassium)) {
      this.storeHarvestPotassium = this.cropProfile.harvest_potassium_content
    }
  },
  methods: {
    onClickNext () {
      this.$router.push({
        name: 'navigatorF3PKStrategy'
      })
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'navigatorF3CropProfile',
        query: {
          doNotSkipCropProfile: true
        }
      })
    }
  }
}
</script>
